
Foreman - Feature #4477

Improve permissions on resources in host creation/editing form

02/27/2014 12:36 PM - Marek Hulán

Status: Closed   

Priority: Normal   

Assignee: Tomer Brisker   

Category: Users, Roles and Permissions   

Target version: 1.13.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link: 1293716 Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/3369

  

Description

We can limit resources that are displayed to the user in host form using new granular permission. Or we could allow resources based

on used hostgroup.

Related issues:

Related to Foreman - Feature #812: cant assign roles to groups, just to users Closed 03/31/2011

Related to Foreman - Feature #1652: Fix privacy for puppetclasses. Resolved

Related to Foreman - Bug #6226: if only one option for required field on new ... New 06/15/2014

Related to Foreman - Bug #6760: Models should ensure the authorization of ass... New 07/23/2014

Related to Foreman - Bug #1875: user restricted to compute resource(s) can cr... New 09/27/2012

Related to Foreman - Feature #7289: ACL who can add a host to hostgroup. New 08/28/2014

Related to Foreman - Bug #18042: Host Compute Resource field does not honor v... New 01/12/2017

Has duplicate Foreman - Bug #6470: Hostgroup selection box does not honor cre... Duplicate 07/02/2014

Has duplicate Foreman - Bug #14248: Unable to control where users can build h... Duplicate 03/17/2016

Associated revisions

Revision a4d69f8c - 06/27/2016 07:19 AM - Tomer Brisker

Fixes #4477 - Host[group] form only show authorized resources

Previously, most dropdowns in the host and hostgroup edit forms

displayed all of the existing resources, including some that a user may

not have been authorized to view.

This commit makes sure only authorized resources are displayed, with the

exception of the current resource - so that editing a host will not

cause changes to its current associations in case the user is not

allowed to see them. This also includes a refactoring of the code to

reduce duplication.

I have also included a change to `with_taxonomy_scope_override` that

allows its use for relations. This was not previously possible due to

the `.unscoped` which was used to remove the default scope and has been

replaced with `.unscope(:where => :taxonomy)` that only removes any

previous taxonomy scopes.

History

#1 - 02/27/2014 12:36 PM - Marek Hulán

- Related to Feature #812: cant assign roles to groups, just to users added

#2 - 03/21/2014 09:26 AM - Dominic Cleal

The same applies to other resources like domains, subnets and realms which have associated smart proxies.  In theory we can use .authorized and

only show the proxies on the form which the user has access to, but in practice this means a user who has edit permissions on a domain but no rights

to view the associated smart proxies might inadvertently unset or change the associated proxy.

Our forms need to be smarter about associations to other resources that the user doesn't have access to.
#3 - 03/31/2014 08:09 AM - Dominic Cleal

- Related to Feature #1652: Fix privacy for puppetclasses. added

#4 - 07/02/2014 09:15 AM - Dominic Cleal

- Has duplicate Bug #6470: Hostgroup selection box does not honor create_hosts filter added

#5 - 07/02/2014 09:23 AM - Dominic Cleal

- Related to Bug #6226: if only one option for required field on new host page (ex. installation media), then automatically select it added

#6 - 07/10/2014 08:24 AM - Bryan Kearney

- Bugzilla link set to 1118312

#7 - 07/28/2014 04:24 AM - Dominic Cleal

- Related to Bug #6760: Models should ensure the authorization of associated objects before associating them to the model added

#8 - 07/31/2014 07:36 AM - Anonymous

- Related to Bug #1875: user restricted to compute resource(s) can create baremetal hosts added

#9 - 07/31/2014 09:35 AM - Anonymous

- Status changed from New to Assigned

- Target version set to 1.7.5

- Assignee set to Anonymous

#10 - 08/20/2014 06:48 AM - Anonymous

- Target version changed from 1.7.5 to 1.7.4

#11 - 08/28/2014 06:17 AM - Dominic Cleal

- Related to Feature #7289: ACL who can add a host to hostgroup. added

#12 - 09/16/2014 08:35 AM - Anonymous

- Target version deleted (1.7.4)

#13 - 09/16/2014 08:35 AM - Anonymous

- Status changed from Assigned to New

#14 - 06/10/2015 12:57 PM - Roy Williams

Once a host group is created it is not possible to change puppet classes from within the host group once hosts are associated to it. However it is

possible to associate puppet classes from the Configure -> Puppet -> Puppet Classes tab and check box them so they will work. The other issue is

it's not possible to populate parameter overrides since I receive the error "Validation failed: Taxonomy has already been taken"

#15 - 06/11/2015 02:58 AM - Marek Hulán

This does not seem related to this authorization issue. Please open a separate issue unless there's an existing one for the issue you have.

Edit (domcleal): #13620

#16 - 03/27/2016 10:35 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3369 added

#17 - 03/27/2016 10:44 AM - Tomer Brisker

- Has duplicate Bug #14248: Unable to control where users can build hosts added

#18 - 03/27/2016 10:50 AM - Tomer Brisker

- Bugzilla link changed from 1118312 to 1293716

- Assignee changed from Anonymous to Tomer Brisker

#19 - 06/27/2016 08:02 AM - Anonymous
https://projects.theforeman.org/issues/13620


- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset a4d69f8c15495ca8e9595f0f1503174e888f30b9.

#20 - 06/27/2016 08:03 AM - Dominic Cleal

- translation missing: en.field_release set to 160

#21 - 01/12/2017 06:40 AM - Tomer Brisker

- Related to Bug #18042: Host Compute Resource field does not honor view permissions added
